// Taks Double Linked List
// Your name: ___________ your name _________________________
//
// The following declaration is necessary to be able
// to declare '_dlist' as a 'DList *' before the Class Dlist
// has actually been defined

class DList;


// The Item class
// This class will serve as a base class for ALL type of items
// that will ever be added to a DList.
// It defines basic functionality

class Item
{
public:
	// constructor/destructor definition
	// note: function bodies still have to be implemented!
    Item();
    ~Item();

    virtual void print(); // why is this one declared as virtual ?? Think about it!!

    // define additional member function here

private:
    Item * _prev;
    Item * _next;
    int _id;
    DList * _dlist;
};

// The DList class
// This class defines basic functionality that one would
// expect from a double linked list.

class DList
{
public:
    DList();
    ~DList();

private:
    Item * _top_of_ring;
};

